#include <windows>
#include <stdio>
#include <alloc>

#include "winlib.h"
#include "winlib.cpp"

// --------------------------------------------------------------------
// zui

SimpleEdit *Cons ; // GfB^ā[A

HWND HCons ;
WNDPROC OrigEditWndProc ;
HFONT EscFont ;
CFONT *EscFontB ;
int EscConsCols ;
int EscConsLines ;
int FontHeight ;
int SBFontWidth ;

typedef union _tag_CWCC_ESC_TEXTATTRIB_{
  long lx ;
  struct{
    unsigned fgcolor:12 ; // 4096 colors
    unsigned bgcolor:12 ;
    unsigned reverce:1 ;
    unsigned blink:1 ; //
    unsigned reserve1:2 ;
    unsigned under:1 ;
    unsigned bold:1 ;
    unsigned italic:1 ;
    unsigned reserv2:1 ;
  }prm ;
  struct{
    unsigned fgc_b:4 ;
    unsigned fgc_g:4 ;
    unsigned fgc_r:4 ;
    unsigned bgc_b:4 ;
    unsigned bgc_g:4 ;
    unsigned bgc_r:4 ;
    unsigned others:8 ;
  } color ;
  struct{
    unsigned fwcolor:12 ;
    unsigned bkcolor:12 ;
    unsigned attr:4 ;
    unsigned ftype:4 ;
  } defs ;
} CWCCTEXTATTR ;

long full_color(int x)
{
	long col ;
	col=((x&0x0f00)<<12) ;
	if(x&0x0f00) col|=0xf0000 ;
	col|=((x&0x00f0)<<8) ;
	if(x&0x00f0) col|=0x00f00 ;
	col|=((x&0x000f)<<4) ;
	if(x&0x000f) col|=0x000f ;
	return(col) ;
}

char DispBuff[32][128] ;
CWCCTEXTATTR Attrib[32][128] ;
WPARAM TmpEscBuff[256] ;
int  TmpEscPos=0 ;
int TextLocateX,TextLocateY ;

void init(int widthx,int heighty)
{
	int i,j ;
	for(i=0 ; i<32 ; i++){
	  for(j=0 ; j<128 ; j++){
	    DispBuff[i][j]=0x00 ;
	    Attrib[i][j].lx=0x00FFF000 ;
	  }
	} ;
	TextLocateX=TextLocateY=0 ;
	if(widthx<40) widthx=40 ;
	if(widthx>120) widthx=120 ;
	if(heighty<20) heighty=20 ;
	if(heighty>30) heighty=30 ;
	EscConsLines=heighty ; EscConsCols=widthx ;
	FontHeight=16 ; SBFontWidth=8 ;
//	strcpy(DispBuff[0],"Ozaki") ; P=5 ;
}

void ScrollUp(void)
{
	int i,j ;
	for(i=0 ; i<31 ; i++){
	  for(j=0 ; j<128 ; j++){
	    DispBuff[i][j]=DispBuff[i+1][j] ;
	    Attrib[i][j]=Attrib[i+1][j] ;
	  }
	}
}

void LineFeed(void)
{
	TextLocateX=0 ;
	TextLocateY++ ;
	if(TextLocateY>=EscConsLines){
	  ScrollUp() ; TextLocateY=EscConsLines-1 ;
	}
}

void DispPaint(PAINTSTRUCT *ps)
{
	int i,j,p ;
	char StrBuff[256] ;
	int fgc,bgc,ox,oy,ofgc,obgc,rvc,orvc ;
	int oftyp,ftype ;
	int OtherFntCret ;
	long xattr ;
	SelectObject(ps->hdc,EscFont) ;
	OtherFntCret=0 ;
	xattr=0x00fff000 ; rvc=0 ; ftype=0 ;
	SetTextColor(ps->hdc,0l) ;
	SetBkColor(ps->hdc,0xffffff) ;
	StrBuff[0]='\0' ;
	for(i=0 ; i<EscConsLines ; i++){
	  ox=0 ; oy=i ; p=0 ;
	  for(j=0 ; j<EscConsCols ; j++){
	    if((Attrib[i][j].lx!=xattr)){ // ̕ύX
	      StrBuff[p]='\0' ;
	      if(p){ // ύXOɁAcΏo
	        TextOut(ps->hdc,ox*SBFontWidth+1,oy*FontHeight+1,
	                                         StrBuff,p) ;
	      }
	      xattr=Attrib[i][j].lx ;
	      oftyp=ftype ;
	      ofgc=fgc ; obgc=bgc ; orvc=rvc ;
	      fgc=Attrib[i][j].prm.fgcolor ;
	      bgc=Attrib[i][j].prm.bgcolor ;
	      rvc=Attrib[i][j].prm.reverce ;
	      ftype=Attrib[i][j].defs.ftype ;
	      if(ftype!=oftyp){ // font typeςB
	        if(OtherFntCret){
	          delete EscFontB ; // ɑĂAɏ
	          OtherFntCret=0 ;
	        }
	        if(ftype==0) SelectObject(ps->hdc,EscFont) ; // ftHgɖ߂
	        else{ // defaultgȂB
	          EscFontB=new CFONT() ;
	          EscFontB->usePreset(PSFONT_GOTHIC,16) ;
	          if(Attrib[i][j].prm.bold) EscFontB->fnWeight=FW_BOLD ;
	          if(Attrib[i][j].prm.italic) EscFontB->fdwItalic=TRUE ;
	          if(Attrib[i][j].prm.under) EscFontB->fdwUnderline=TRUE ;
	          SelectObject(ps->hdc,EscFontB->Create()) ;
	          OtherFntCret=1 ;
	        }
	      }
	      if(orvc!=rvc){ // ]ς
	        if(rvc){
	          SetTextColor(ps->hdc,full_color(bgc)) ;
	          SetBkColor(ps->hdc,full_color(fgc)) ;
	        }
	        else{
	          SetTextColor(ps->hdc,full_color(fgc)) ;
	          SetBkColor(ps->hdc,full_color(bgc)) ;
	        }
	      }
	      else{
	        if(ofgc!=fgc) SetTextColor(ps->hdc,full_color(fgc)) ;
	        if(obgc!=bgc) SetBkColor(ps->hdc,full_color(bgc)) ;
	      }
	      ox=j ; oy=i ; p=0 ;
	    }
	    if(DispBuff[i][j]==0x00) DispBuff[i][j]=0x20 ;
	    StrBuff[p++]=DispBuff[i][j] ;
	  }
	  // sʒu
	  if(p){ // cL΁AUo͂sB
	    StrBuff[p]='\0' ;
	    TextOut(ps->hdc,ox*SBFontWidth+1,oy*FontHeight+1,
	                                     StrBuff,p) ;
	    xattr=Attrib[i][j].lx ;
	  }
	}
	if(OtherFntCret) delete EscFontB ; // n
}

int IsSjis(int ch)
{
	ch&=0x00ff ;
	if(ch>=0x80 && ch<=0x9f) return(1) ;
	if(ch>=0xe0 && ch<=0xfc) return(1) ;
	return(0) ;
}

#define DEFAULT_ATTRIBUTE 0x00FFF000
#define TEXTATTR_REVERCE 0x01000000
#define TEXTATTR_BLINK   0x02000000
#define TEXTATTR_STOPREV 0xFEFFFFFF
#define TEXTATTR_STOPBLK 0xFDFFFFFF
#define ID_OUTPUT_FINISH (WPARAM)0x8000 

long CESC_CurrentAttr=DEFAULT_ATTRIBUTE ;
BOOL RepaintFlg=FALSE ;

void DispBuffInput(WPARAM wpm)
{
	if(wpm<0x20) return ;
	if(TextLocateX>=EscConsCols) LineFeed() ;
	if(wpm&0xff00){ // 2byte
	  DispBuff[TextLocateY][TextLocateX]=(wpm&0x00ff) ;
	  Attrib[TextLocateY][TextLocateX].lx=CESC_CurrentAttr ;
	  TextLocateX++ ;
	  wpm=(wpm>>8) ;
	}
	DispBuff[TextLocateY][TextLocateX]=(wpm&0x00ff) ;
	Attrib[TextLocateY][TextLocateX].lx=CESC_CurrentAttr ;
	TextLocateX++ ;
	RepaintFlg=TRUE ;
}

void DispBuffClear(void)
{
	int i,j ;
	for(i=0 ; i<32 ; i++){
	  for(j=0 ; j<128 ; j++){
	    DispBuff[i][j]=0x00 ;
	    Attrib[i][j].lx=0x00FFF000 ;
	  }
	}
	TextLocateX=TextLocateY=0 ;
}

int  EscNumberBuff[256] ; // ;ŋ؂ꂽԍ擾B

int  GetEscNumb(int Spos)
{
	int i,j,c ;
	char nbuf[256] ;
	
	for(i=Spos,j=0 ; i<TmpEscPos ; i++){
	  c=TmpEscBuff[i] ; c&=0x00ff ;
	  if(c==0x20 && j==0) continue ; // ŏ̃Xy[X̓Jbg
	  if(c<0x30 && c>0x39) break ;
	  nbuf[j++]=c ;
	}
	nbuf[j]='\0' ;
	if(j==0) return(-1) ;
	return((int)(atol(nbuf))) ;
}

int GetEscNumbers(int Spos)
{
	int i,p ;
	p=0 ;
	EscNumberBuff[p++]=GetEscNumb(Spos) ;
	for(i=Spos ; i<TmpEscPos ; i++){
	  if(TmpEscBuff[i]==';'){
	    i++ ;
	    EscNumberBuff[p++]=GetEscNumb(i) ;
	  }
	}
	return(p) ;
}

void EscColorChange(int Ax)
{
	int Axc,Axm ;
	CWCCTEXTATTR temp ;
	Axm=(Ax%10) ;
	if(Axm>7) return ;
	temp.lx=CESC_CurrentAttr ;
	Axc=0 ;
	if(Axm&0x01) Axc|=0x0f00 ;
	if(Axm&0x02) Axc|=0x00f0 ;
	if(Axm&0x04) Axc|=0x000f ;
	if(Ax>=50) Axc&=0x0777 ;
	if(Ax>=60){ temp.prm.bgcolor=Axc ; }
	else if(Ax>=50){ temp.prm.fgcolor=Axc ; }
	else if(Ax>=40){ temp.prm.bgcolor=Axc ; }
	else{ temp.prm.fgcolor=Axc ; }
	CESC_CurrentAttr=temp.lx ;
}

#define FTYPE_NORMAL 0
#define FTYPE_UNDER  1
#define FTYPE_BOLD   2
#define FTYPE_ITALIC  4

void EscFTypeChange(int addtype)
{
	CWCCTEXTATTR temp ;
	temp.lx =CESC_CurrentAttr ;
	if(addtype==FTYPE_NORMAL) temp.defs.ftype=addtype ;
	else temp.defs.ftype|=addtype ;
	CESC_CurrentAttr=temp.lx ;
}

void EscSeqCollection(WPARAM cwpm)
{
	int i,nnb,tX,tY,At ;
	if(TmpEscBuff[0]!=0x001b || TmpEscPos==0){
	  TmpEscPos=0 ;
	  return ;
	}
	if(cwpm==0x0000){ // ł؂
	  if(TmpEscBuff[0]==0x001b && TmpEscPos>2){
	    for(i=2 ; i<TmpEscPos ; i++) DispBuffInput(TmpEscBuff[i]) ;
	  }
	  TmpEscPos=0 ;
	}
	else if(TmpEscPos<250){
	  TmpEscBuff[TmpEscPos++]=cwpm ;
	  cwpm&=0x00ff ;
	  // ȉAꂼ̃^[~l[^M𓾂āAt@NV{B
	  if(cwpm=='B' && TmpEscPos==2){ // fobO@ESC B=Bold({͈Ⴄ)
	    EscFTypeChange(FTYPE_BOLD) ;
	    TmpEscPos=0 ;
	  }
	  if(cwpm=='I' && TmpEscPos==2){ // fobO@ESC I=Italic
	    EscFTypeChange(FTYPE_ITALIC) ;
	    TmpEscPos=0 ;
	  }
	  if(cwpm=='*' && TmpEscPos==2){
	    DispBuffClear() ;
	    EscFTypeChange(FTYPE_NORMAL) ;
	    RepaintFlg=TRUE ;
	    TmpEscPos=0 ;
	  }
	  if((cwpm=='H' || cwpm=='f') && TmpEscBuff[1]=='['){
	    nnb=GetEscNumbers(2) ;
	    if(nnb>=2){
	      tY=EscNumberBuff[0] ;
	      tX=EscNumberBuff[1] ;
	      if(tY>=EscConsLines) tY=EscConsLines-1 ;
	      if(tX>=EscConsCols)  tX=EscConsCols-1 ;
	      if(tY>=0) TextLocateY=tY ;
	      if(tX>=0) TextLocateX=tX ;
	    }
	    TmpEscPos=0 ;
	  }
	  if(cwpm=='m' && TmpEscBuff[1]=='['){ //
	    nnb=GetEscNumbers(2) ;
	    //TmpEscBuff[TmpEscPos-1]='\0' ;
	    for(i=0 ; i<nnb ; i++){
	      At=EscNumberBuff[i] ;
	      if(At>=17 && At<=23){
	        At=((At&0xf9)|((At&0x04)>>1)|((At&0x02)<<1))+14 ; 
	        // 31-37ɍ킹
	      }
	      
	      if(At<=0) CESC_CurrentAttr=DEFAULT_ATTRIBUTE ;
	      else if(At==4) CESC_CurrentAttr&=TEXTATTR_STOPBLK ;
	      else if(At==5) CESC_CurrentAttr|=TEXTATTR_BLINK ;
	      else if(At==6) CESC_CurrentAttr&=TEXTATTR_STOPREV ;
	      else if(At==7) CESC_CurrentAttr|=TEXTATTR_REVERCE ;
	      else if(At>=30 && At<=67) EscColorChange(At) ;
	      // else{} // ȊO͖
	    }
	    TmpEscPos=0 ;
	  }
	}
}

class ESC_MOUSE{
	public:
	  ESC_MOUSE(){} ;
	  virtual ~ESC_MOUSE(){} ;
	  virtual void LButtonDown(WPARAM wpm,int x,int y){} ;
	  virtual void LButtonUp(WPARAM wpm,int x,int y){} ;
	  virtual void LButtonDouble(WPARAM wpm,int x,int y){} ;
	  virtual void MButtonDown(WPARAM wpm,int x,int y){} ;
	  virtual void MButtonUp(WPARAM wpm,int x,int y){} ;
	  virtual void MButtonDouble(WPARAM wpm,int x,int y){} ;
	  virtual void RButtonDown(WPARAM wpm,int x,int y){} ;
	  virtual void RButtonUp(WPARAM wpm,int x,int y){} ;
	  virtual void RButtonDouble(WPARAM wpm,int x,int y){} ;
} ;

class EscMouseControl{
	private:
	  ESC_MOUSE *EscMouse ;
	public:
	  EscMouseControl(){ EscMouse=new ESC_MOUSE() ; }
	  ~EscMouseControl(){ delete EscMouse ; }
	  void SetUserEscMouse(ESC_MOUSE *UserMouse){
	    delete EscMouse ;
	    EscMouse=UserMouse ;
	  } ;
	  void Action(UINT msg,WPARAM wpm,LPARAM lpm) ;
} ;

void EscMouseControl::Action(UINT msg,WPARAM wpm,LPARAM lpm)
{
	int x,y ;
	x=LOWORD(lpm) ;
	y=HIWORD(lpm) ;
	switch(msg){
	  case WM_LBUTTONDOWN:
	    EscMouse->LButtonDown(wpm,x,y) ; break ;
	  case WM_LBUTTONDBLCLK:
	    EscMouse->LButtonDouble(wpm,x,y) ; break ;
	  case WM_LBUTTONUP:
	    EscMouse->LButtonUp(wpm,x,y) ; break ;

	  case WM_MBUTTONDBLCLK:
	    EscMouse->MButtonDouble(wpm,x,y) ; break ;
	  case WM_MBUTTONDOWN:
	    EscMouse->MButtonDown(wpm,x,y) ; break ;
	  case WM_MBUTTONUP:
	    EscMouse->MButtonUp(wpm,x,y) ; break ;

	  case WM_RBUTTONDBLCLK:
	    EscMouse->RButtonDouble(wpm,x,y) ; break ;
	  case WM_RBUTTONDOWN:
	    EscMouse->RButtonDown(wpm,x,y) ; break ;
	  case WM_RBUTTONUP:
	    EscMouse->RButtonUp(wpm,x,y) ; break ;
	}
}

EscMouseControl CwccMouse ;

LPARAM CwccEscWndProc(HWND hwnd,UINT msg,WPARAM wpm,LPARAM lpm)
{
	PAINTSTRUCT ps ;
	switch(msg){
	  case WM_LBUTTONDOWN:
	  case WM_LBUTTONDBLCLK:
	  case WM_LBUTTONUP:
	  case WM_MBUTTONDBLCLK:
	  case WM_MBUTTONDOWN:
	  case WM_MBUTTONUP:
	  case WM_RBUTTONDBLCLK:
	  case WM_RBUTTONDOWN:
	  case WM_RBUTTONUP:
	    CwccMouse.Action(msg,wpm,lpm) ;
	    return(0l) ;
	  case WM_CHAR: ;
	    // { PꂽP߂B
	    // 16bitȂQ߂B80zs
	    if(TmpEscPos){ // EscSeqW
	      EscSeqCollection(wpm) ;
	    }
	    else if(wpm>=0x20){
	      DispBuffInput(wpm) ;
	    }
	    else{
	      if(wpm==0x0d || wpm==0x0a){
	        if(TmpEscPos) EscSeqCollection((WPARAM)0x00) ;
	        LineFeed() ; RepaintFlg=1 ;
	      }
	      else if(wpm==0x08 && TextLocateX!=0){
	        DispBuff[TextLocateY][TextLocateX-1]=0x20 ;
	        Attrib[TextLocateY][TextLocateX-1].lx=0x00fff000 ;
	        TextLocateX-- ;
	        if(TextLocateX>0 && IsSjis(DispBuff[TextLocateY][TextLocateX-1])){
	          DispBuff[TextLocateY][TextLocateX-1]=0x20 ;
	          Attrib[TextLocateY][TextLocateX-1].lx=0x00fff000 ;
	          TextLocateX-- ;
	        }
	        RepaintFlg=1 ;
	      }
	      else if(wpm==0x09){
	        TextLocateX++ ;
	        while(TextLocateX&0x0003) TextLocateX++ ;
	        if(TextLocateX>=EscConsCols) TextLocateX=EscConsCols ;
	      }
	      else if(wpm==0x1b){ //\x1b
	        if(TmpEscPos) EscSeqCollection((WPARAM)0x00) ;
	        TmpEscPos=1 ;
	        TmpEscBuff[0]=0x1b ;
	      }
	    }
	    return(0l) ;
	  case WM_PAINT:
	    BeginPaint(hwnd,&ps) ;
	    DispPaint(&ps) ;
	    EndPaint(hwnd,&ps) ;
	    return(0l) ;
	  //break ;
	  case WM_USER:
	    if(wpm==ID_OUTPUT_FINISH){
	      if(RepaintFlg){
	        RECT GCRect;
	        GetClientRect(hwnd,&GCRect) ;
	        InvalidateRect(hwnd,&GCRect,TRUE) ;
	        UpdateWindow(hwnd) ;
	      }
	      RepaintFlg=FALSE ;
	      return(0) ;
	    }
	}
	return(CallWindowProc(OrigEditWndProc,hwnd,msg,wpm,lpm)) ;
}

class MCApp : public WinApp{
	public:
	  MCApp(HINSTANCE hi): WinApp(hi){} ;
	  virtual ~MCApp() ;
	  virtual void OnCreate(HWND) ;
	  virtual void OnCommand(HWND,WPARAM,LPARAM) ;
	  virtual BOOL OnDefault(HWND,UINT,WPARAM,LPARAM) ;
} ;

MCApp::~MCApp()
{
	delete Cons ;
}

void MCApp::OnCreate(HWND hwnd)
{
	char buff[256] ;
	Cons=new SimpleEdit(hwnd,TRUE,FALSE) ;
	Cons->Create("",10,10,SBFontWidth*EscConsCols+2,
	                            FontHeight*EscConsLines+2) ;
	Cons->SetFont(PSFONT_GOTHIC,16) ;
	EscFont=Cons->FONT.GetFont() ;
//	EscFontB.usePreset(PSFONT_GOTHIC,16) ;
//	EscFontB.fnWeight=FW_BOLD ;
//	EscFontB.Create() ;
	HCons=Cons->GetHandle() ;
	OrigEditWndProc=(WNDPROC)GetWindowLong(HCons,GWL_WNDPROC) ;
	SetWindowLong(HCons,GWL_WNDPROC,(LONG)CwccEscWndProc) ;
//	Cons->Enable(DISABLE) ;
}

void MCApp::OnCommand(HWND hwnd,WPARAM wParam,LPARAM)
{
	char buff[1024] ;
	long xl ;
	if(Cons->IsYourEvent(wParam)){
	  ;
	}
}

BOOL MCApp::OnDefault(HWND hwnd,UINT msg,WPARAM wp,LPARAM lp)
{
	if(msg==WM_CHAR){
	  PostMessage(HCons,msg,wp,lp) ;
	  PostMessage(HCons,WM_USER,ID_OUTPUT_FINISH,0l) ;
	  return(FALSE) ;
	}
	return(FALSE) ;
}

class MyMouse : public ESC_MOUSE{
	public:
	  virtual ~MyMouse(){} ;
	  virtual void LButtonDown(WPARAM,int,int) ;
} ;

void MyMouse::LButtonDown(WPARAM,int x,int y)
{
	char buff[256] ;
	wsprintf(buff,"x=%d y=%d",x,y) ;
	MessageBox(HWND_DESKTOP,buff,"test",MB_OK) ;
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
  LPSTR,int nCmdShow)
{
	char TITLE_MESSAGE[256] ;
	init(40,20) ;
	CwccMouse.SetUserEscMouse(new MyMouse()) ;
	FrameWindow MFrame(new MCApp(hInstance),hPrevInstance,nCmdShow) ;
	wsprintf(TITLE_MESSAGE,"TEST") ;
	return(MFrame.FrameWork(TITLE_MESSAGE,320+40,320+20)) ;
}

